unit hiMST_EditCtrlManager;

interface
     
uses Windows, Messages, Kol, Share, Debug, hiMTStrTbl;

type
  THIMST_EditCtrlManager = class(TDebug)
   private
     sControl: PControl;
     NewLine: integer;

     procedure snewcuridx(value:integer);
     function gnewcuridx:integer;
     function fredaction: boolean;
     function fctl3d: boolean;     
   public
     _prop_MSTControl: IMSTControl;
     _prop_KeyCellEnter: byte;
     _event_onEscCell: THI_Event;
     _event_onMT_CellEnter: THI_Event;
          
     property NewCurIdx:integer read gnewcuridx write snewcuridx;
     
     procedure _work_doSetFocus(var _Data:TData; Index:word);
     procedure _work_doInitEditCtrl(var _Data:TData; Index:word);     
     procedure _var_Index(var _Data:TData; Index:word);
     procedure _var_Select(var _Data:TData; Index:word);
     procedure _var_Cell(var _Data:TData; Index:word);
     procedure _var_SubItem(var _Data:TData; Index:word);    

     procedure _var_Matrix(var _Data:TData; Index:word);           
  end;

implementation


//------------------------------------------------------------------------------
//
function WndProcTabGrid(Sender: PControl; var Msg: TMsg; var Rslt: Integer): Boolean;
type
  TMouseDownPt = packed record
    X: Word;
    Y: Word;
  end;
var
  R, ARect: TRect;
  Pt: TMouseDownPt; 
  HTI: TLVHitTestInfo;
  fClass: THIMST_EditCtrlManager;
  dTop, dWidth, dHeight, Data:TData;
  l: TListViewOptions;

  procedure InitOnEvent(NewLine, NewCurIdx: integer);
  var
    b: integer;
  begin
    if not (lvoRowSelect in l) or fClass.FRedaction then exit;
    R := Sender.LVSubItemRect(NewLine, NewCurIdx);
    if NewCurIdx = 0 then
    begin
      ARect := Sender.LVItemRect(NewLine, lvipLabel);
      R.Left := ARect.Left;
      R.Right := ARect.Right;
    end; 
    if fClass.fctl3d then
      b := 2
    else
      b := 1;
    dtInteger(Data,R.Left + Sender.Left + b);
    dtInteger(dTop,R.Top + Sender.Top + b);

    dtInteger(dWidth, R.Right - R.Left);
    dtInteger(dHeight, R.Bottom - R.Top);  
    Data.ldata:= @dTop;
    dTop.ldata:= @dWidth;
    dWidth.ldata:= @dHeight;
    _hi_OnEvent_(fClass._event_onMT_CellEnter, Data);
  end;

  procedure EscCell(NewLine: integer);
  begin
    R := Sender.LVItemRect(NewLine, lvipBounds);
    ARect := Sender.LVItemRect(NewLine, lvipLabel);
    R.Left := ARect.Left;
    InvalidateRect(Sender.Handle, @R, false);
    if (lvoRowSelect in l) and not fClass.FRedaction then 
      _hi_OnEvent(fClass._event_onEscCell);
  end;
  
begin
  Result := FALSE;
  l:= Sender.LVOptions;
  fClass := THIMST_EditCtrlManager(Sender.Tag);
  with fClass do
  begin
    case Msg.message of
      WM_RBUTTONDOWN, WM_LBUTTONDOWN:
      begin
        Pt:= TMouseDownPt(Msg.lParam);
        HTI.pt.x := Pt.X;
        HTI.pt.y := Pt.Y;
        Sender.Perform( LVM_SUBITEMHITTEST, 0, Integer( @HTI ) );
        if HTI.flags <> LVHT_ONITEMSTATEICON then
        begin 
          NewLine := HTI.iItem;
          NewCurIdx := HTI.iSubItem;             
        end;
        EscCell(NewLine);
      end;
      WM_LBUTTONDBLCLK:
        begin
          Pt:= TMouseDownPt(Msg.lParam);
          HTI.pt.x := Pt.X;
          HTI.pt.y := Pt.Y;
          Sender.Perform( LVM_SUBITEMHITTEST, 0, Integer( @HTI ) );
          if HTI.flags <> LVHT_ONITEMSTATEICON then     
            InitOnEvent(NewLine, NewCurIdx);
          end;
      WM_HSCROLL, WM_VSCROLL:
        EscCell(NewLine);
      WM_KEYDOWN:
      begin
        Case Msg.WParam of
          VK_LEFT, VK_RIGHT:
          begin
            if (lvoRowSelect in l) then
            begin
              NewCurIdx := NewCurIdx + Msg.wParam - $26;
              if NewCurIdx >= Sender.LVColCount then
                NewCurIdx := Sender.LVColCount - 1
              else
                if NewCurIdx < 0 then NewCurIdx := 0;
              EscCell(NewLine);
            end;
          end;
          VK_UP, VK_DOWN:
          begin
            if (lvoRowSelect in l) then
            begin
              NewLine := NewLine + Msg.wParam - $27;                  
              if NewLine >= Sender.Count then
                NewLine := Sender.Count - 1
              else
                if NewLine < 0 then
                  NewLine := 0;
              EscCell(NewLine);
            end;
          end;
          VK_RETURN:
            if _prop_KeyCellEnter = 1 then
              InitOnEvent(NewLine, NewCurIdx);            
          VK_F2:
            InitOnEvent(NewLine, NewCurIdx);
          VK_ESCAPE:
            EscCell(NewLine);
        end;
      end;
    end;
  end;
end;

procedure THIMST_EditCtrlManager.snewcuridx;
begin
  if not Assigned(_prop_MSTControl) then exit;
  _prop_MSTControl.setnewcuridx(value);  
end;

function THIMST_EditCtrlManager.gnewcuridx;
begin
  if Assigned(_prop_MSTControl) then
    Result := _prop_MSTControl.getnewcuridx  
  else
    Result := 0;
end;

function THIMST_EditCtrlManager.fredaction;
begin
  if Assigned(_prop_MSTControl) then
    Result := _prop_MSTControl.getfredaction  
  else
    Result := true;
end;

function THIMST_EditCtrlManager.fctl3d;    
begin
  if Assigned(_prop_MSTControl) then
    Result := _prop_MSTControl.getfctl3d  
  else
    Result := true;
end;

//    Edit 
//
procedure THIMST_EditCtrlManager._work_doInitEditCtrl;
begin
  if not Assigned(_prop_MSTControl) then exit;
  sControl := _prop_MSTControl.ctrlpoint;
  _prop_MSTControl.detachwndproc;
  sControl.Tag := Cardinal(Self);
  sControl.AttachProc(WndProcTabGrid);
end;

//     
//
procedure THIMST_EditCtrlManager._var_SubItem;
begin
  if not Assigned(_prop_MSTControl) then exit;
  dtInteger(_Data, _prop_MSTControl.getnewcuridx);
end;

//      
//
procedure THIMST_EditCtrlManager._var_Cell;
var
  dControl: PControl;
begin
  if not Assigned(_prop_MSTControl) then exit;
  dControl := _prop_MSTControl.ctrlpoint; 
  dtString(_Data, dControl.LVItems[sControl.LVCurItem, _prop_MSTControl.getnewcuridx]);
end;

//     ,   StrDelimiter
//
procedure THIMST_EditCtrlManager._var_Select;
var
  sControl: PControl;
begin
  if not Assigned(_prop_MSTControl) then exit;
  sControl := _prop_MSTControl.ctrlpoint;
  if sControl.LVCurItem = -1 then
    dtString(_Data, '')
   else
    dtString(_Data, _prop_MSTControl.getstring(sControl.LVCurItem));
end;

//    
//
procedure THIMST_EditCtrlManager._var_Index;
var
  sControl: PControl;
begin
  if not Assigned(_prop_MSTControl) then exit;
  sControl := _prop_MSTControl.ctrlpoint;
  dtInteger(_Data, sControl.CurIndex);
end;

//  
//
procedure THIMST_EditCtrlManager._var_Matrix;
begin
  if not Assigned(_prop_MSTControl) then exit;
  _prop_MSTControl.matrix(_Data);    
end;

//    
//
procedure THIMST_EditCtrlManager._work_doSetFocus;
begin
  if not Assigned(_prop_MSTControl) then exit;
  _prop_MSTControl.setfocus(_Data, 0);
end;

end.