unit hiMST_EventManager;

interface
     
uses Windows, Messages, Kol, Share, Debug;

type
  TIEventManager = record
    onclick:procedure(IdxFrom: integer) of object;
    oncolumnclick:procedure(Data: TData) of object;
    oncheckmt:procedure(Data: TData) of object;
    onbeforelinechange:procedure(Idx: integer) of object;
    onlinechange:procedure(Idx: integer) of object;
    onchange:procedure of object;
    onchangecollst:procedure of object;
  end;
  IEventManager = ^TIEventManager;

  THIMST_EventManager = class(TDebug)
   private
     em: TIEventManager;                  
     procedure onclick(IdxFrom: integer);
     procedure oncolumnclick(Data: TData);
     procedure oncheckmt(Data: TData);
     procedure onbeforelinechange(Idx: integer);
     procedure onlinechange(Idx: integer);
     procedure onchange;
     procedure onchangecollst;
   public
     _event_onClick:THI_Event;
     _event_onColumnClick:THI_Event;
     _event_onChange:THI_Event;
     _event_onChangeColLst:THI_Event;          
     _event_onCheck_MT:THI_Event;
     _event_onBeforeLineChange:THI_Event;
     _event_onLineChange:THI_Event;

     _prop_Name:string;
     _prop_EventManager:IEventManager;

     constructor Create;
     destructor Destroy; override;
     function getInterfaceEventManager:IEventManager;
  end;

implementation

constructor THIMST_EventManager.Create;
begin
  inherited;
  em.onclick := onclick;
  em.oncolumnclick := oncolumnclick;
  em.oncheckmt := oncheckmt;
  em.onbeforelinechange := onbeforelinechange;
  em.onlinechange := onlinechange;
  em.onchange := onchange;
  em.onchangecollst := onchangecollst; 
end;

destructor THIMST_EventManager.Destroy;
begin
  inherited;
end; 

function THIMST_EventManager.getInterfaceEventManager;
begin
  Result := @em;
end;

procedure THIMST_EventManager.onclick;
begin
  _hi_OnEvent(_event_onClick, IdxFrom);
  if Assigned(_prop_EventManager) then
    _prop_EventManager.onclick(IdxFrom);
end;

procedure THIMST_EventManager.oncolumnclick;
begin
  _hi_OnEvent(_event_onColumnClick, Data);
  if Assigned(_prop_EventManager) then
    _prop_EventManager.oncolumnclick(Data);
end;

procedure THIMST_EventManager.oncheckmt;
begin
  _hi_onEvent_(_event_onCheck_MT, Data);
  if Assigned(_prop_EventManager) then
    _prop_EventManager.oncheckmt(Data);  
end;

procedure THIMST_EventManager.onbeforelinechange;
begin
  _hi_OnEvent(_event_onBeforeLineChange, Idx);
  if Assigned(_prop_EventManager) then  
  _prop_EventManager.onbeforelinechange(idx);
end;

procedure THIMST_EventManager.onlinechange;
begin
  _hi_OnEvent(_event_onLineChange, Idx);
  if Assigned(_prop_EventManager) then  
    _prop_EventManager.onlinechange(idx);  
end;

procedure THIMST_EventManager.onchange;
begin
  _hi_onEvent(_event_onChange);
  if Assigned(_prop_EventManager) then
    _prop_EventManager.onchange;
end;

procedure THIMST_EventManager.onchangecollst;
begin
  _hi_onEvent(_event_onChangeColLst);
  if Assigned(_prop_EventManager) then
    _prop_EventManager.onchangecollst;
end; 

end.