unit hiMST_InitTxtTab;

interface
     
uses Kol, Share, Debug, hiMTStrTbl, hiMST_EventManager;

type
  THIMST_InitTxtTab = class(TDebug)
  private
    FAppend: boolean;
    procedure Add(const Data:string; Index:integer = -1; _Replace:boolean = false);
  public
    _prop_MSTControl:IMSTControl;
    _prop_EventManager:IEventManager;    
    _data_Text:THI_Event;
    _event_onChange:THI_Event;
    property  _prop_Append: boolean write FAppend;
    procedure _work_doAppend(var _Data:TData; Index:word);
    procedure _work_doInitTxtTab(var _Data:TData; Index:word);
    procedure _var_FullTextTab(var _Data:TData; Index:word);
  end;

implementation

//     
// ARG(Text)
//
procedure THIMST_InitTxtTab._work_doInitTxtTab;
var
  List: PStrList;
  ind: integer;
  sControl: PControl;
begin
  if not Assigned(_prop_MSTControl) then exit;
  sControl := _prop_MSTControl.ctrlpoint;
  sControl.BeginUpdate;
  if not FAppend then
    sControl.Clear;
  List := NewStrList;
  List.Text := ReadString(_Data, _data_Text);
  for ind := 0 to List.Count - 1 do
  Add(List.Items[ind]);
//  _prop_MSTControl.add(List.Items[ind]);
  List.free;
  sControl.EndUpdate;
  _hi_onEvent(_event_onChange);
  if Assigned(_prop_EventManager) then
    _prop_EventManager.onchange;
end;

//        
//        10  13
//
procedure THIMST_InitTxtTab._var_FullTextTab;
var
  i, j: integer;
  s: string;
  sControl: PControl;
begin
  if not Assigned(_prop_MSTControl) then exit;
  sControl := _prop_MSTControl.ctrlpoint;

//  if (sControl.Count = 0) or (sControl.LVColCount = 0) then Exit;
  if (sControl.Count = 0) then Exit;
  s := '';
  j := 0;
  repeat
  if (Assigned(_prop_MSTControl.smiconlist) and (sControl.LVStyle <> lvsIcon)) or
     (Assigned(_prop_MSTControl.lgiconlist) and (sControl.LVStyle = lvsIcon))  then
      s := s + int2str(sControl.LVItemImageIndex[j]) + _prop_MSTControl.getstrdlm;
    if _prop_MSTControl.coloritems then
      s := s + _prop_MSTControl.pakcolortostr(sControl.LVItemData[j]) + _prop_MSTControl.getstrdlm;
    i := 0;
    repeat
      s := s + sControl.LVItems[j,i];
      if i < sControl.LVColCount - 1 then
        s := s + _prop_MSTControl.getstrdlm;
      inc(i);
    until i > sControl.LVColCount - 1; 
    s := s + #13#10;
    inc(j);
  until j > sControl.Count - 1;
  dtString(_Data, s);
end;

//      
//
procedure THIMST_InitTxtTab.Add;
var
  s, ss: string;
  i, ico, ind: integer;
  DColor: Cardinal;       
  sControl: PControl;
begin
  if not Assigned(_prop_MSTControl) then exit;
  sControl := _prop_MSTControl.ctrlpoint;

  s := Data + _prop_MSTControl.getstrdlm;
  i := 0;
  ico := I_SKIP;
  DColor := 0;
  if Index = -1 then
  begin
    sControl.LVItemAdd('');
    Index := sControl.Count - 1;
  end
  else if not _replace then
    sControl.LVItemInsert(Index,'');
  if (Assigned(_prop_MSTControl.smiconlist) and (sControl.LVStyle <> lvsIcon)) or
     (Assigned(_prop_MSTControl.lgiconlist) and (sControl.LVStyle = lvsIcon))  then
    ico := Str2Int(GetTok(s, _prop_MSTControl.getstrdlm));
  if _prop_MSTControl.coloritems then
  begin
    ss:= GetTok(s, _prop_MSTControl.getstrdlm) + _prop_MSTControl.getcolordlm;
    DColor:= Cardinal(Str2Int(GetTok(ss, _prop_MSTControl.getcolordlm)) shl 24 + Str2int(ss));
  end;
  ind := sControl.LVCurItem; //    
  repeat
    sControl.LVSetItem(Index, i, GetTok(s, _prop_MSTControl.getstrdlm), ico, [], I_SKIP, I_SKIP, DColor);
    inc(i);
  until s = '';
  sControl.LVCurItem := ind; //   
end;

procedure THIMST_InitTxtTab._work_doAppend;
begin
  FAppend := ReadBool(_Data);
end;

end.