unit hiMTStrTbl; { MT-   }

interface

uses Windows, Messages, Share, Win, Debug, ListEdit, Kol,
     hiIconsManager, hiMST_DrawManager, hiMST_EventManager;

const
  ITM_ADD     =  -3;
  ITM_INSERT  =  -4;
  ITM_REPLACE =  -5;

  COL_NAME    =  -9;
  COL_WIDTH   = -10;
  COL_IMAGE   = -11;
  COL_ALIGN   = -12;

type
  TIMSTControl = record
    ctrlpoint:      function:pointer of object;
    actionitm:      procedure(var Data:TData; Mode:integer) of object;
    actioncol:      procedure(var Data:TData; Mode:integer) of object;    
    propercol:      procedure(var Data:TData; Mode:integer) of object;
    textalign:      function(idx:integer):TTextAlign of object;    
    imgcolumn:      function:boolean of object;
    smiconlist:     function:PImageList of object;
    lgiconlist:     function:PImageList of object;    
    colcount:       function:integer of object;
    imgsize:        function:byte of object;
    coloritems:     function:boolean of object;
    scoloritems:    procedure(val:boolean) of object;
    textbkcolor:    function: TColor of object;
    textcolor:      function: TColor of object;
    bkcolor:        function: TColor of object;
    gradientcolor:  function: TColor of object;
    shadowcolor:    function: TColor of object;
    iconcolcolor:   function: TColor of object;
    addcols:        procedure(var _Data:TData; FAllMT_AddCol:boolean) of object;
    stextbkcolor:   procedure(Value: TColor) of object;
    stextcolor:     procedure(Value: TColor) of object;
    sbkcolor:       procedure(Value: TColor) of object;
    sgradientcolor: procedure(Value: TColor) of object;
    sshadowcolor:   procedure(Value: TColor) of object;
    siconcolcolor:  procedure(Value: TColor) of object;
    deletecol:      procedure(var _Data:TData) of object;
    clistclear:     procedure of object;
    clistcount:     function:integer of object;
    style:          function:TListViewStyle of object;
    setfocus:       procedure(var _Data:TData; Index:word) of object;
    getnewcuridx:   function:integer of object;
    setnewcuridx:   procedure(value:integer) of object;
    getfredaction:  function:boolean of object;
    getfctl3d:      function:boolean of object;
    matrix:         procedure(var _Data:TData) of object;
    mxget:          function(x,y:integer):TData of object;
    mxset:          procedure(x,y:integer; var Val:TData) of object;
    pakcolortostr:  function(Data:Cardinal):string of object;
    getstrdlm:      function:char of object;
    getcolordlm:    function:char of object;
    detachwndproc:  procedure of object;
    getstring:      function(index:integer):string of object;
    columnarray:    procedure(var _Data:TData) of object;    
  end;
  IMSTControl = ^TIMSTControl;

type
  ThiMTStrTbl = class(THIWin)
  private
    mtstc: TIMSTControl; 
   
    FLargIconsManager:IIconsManager;
    FSmallIconsManager:IIconsManager;
    FStateIconsManager:IIconsManager;

    NewCurIdx,
    NewLine: integer;
    Obj:PMatrix;
    CLArray: PArray;
    LgIList,
    SmIList,
    StIList: PImageList;
    CList: PStrList;
    _StrDlm: Char;
    _ColorDlm:Char;
    _ColDlm:Char;
    
    FStyle: TListViewStyle;
    FTextAlign: TTextAlign;

    FColorItems,
    FGrid,
    FTrackSelect,
    FMultiSelect,
    FImgColumn,
    FFullSelect,
    FRedaction,
    FEnableOnClick,
    FInfoTip: boolean;    

    FColumnClick,
    FImgSize: byte;

    FColumnWidth:integer;

    FIconColColor,
    FGradientColor,
    FShadowColor: TColor;

    function  ctrlpoint: pointer;
    function  smiconlist: PImageList;
    function  lgiconlist: PImageList;
    function  textalign(idx:integer): TTextAlign;
    function  imgcolumn: boolean;
    function  colcount: integer;
    function  imgsize: byte;    
    function  coloritems: boolean;
    procedure scoloritems(val:boolean);    
    function  textbkcolor: TColor;
    function  textcolor: TColor;
    function  bkcolor: TColor;
    function  gradientcolor: TColor;
    function  shadowcolor: TColor;
    function  iconcolcolor: TColor;
    procedure addcols(var _Data:TData; FAllMT_AddCol:boolean);
    procedure stextcolor(Value: TColor);
    procedure stextbkcolor(Value: TColor);
    procedure sbkcolor(Value: TColor);
    procedure sgradientcolor(Value: TColor);
    procedure sshadowcolor(Value: TColor);
    procedure siconcolcolor(Value: TColor);
    procedure deletecol(var _Data:TData);
    procedure clistclear;
    function  clistcount:integer;
    function  style:TListViewStyle;
    function  getnewcuridx:integer;
    procedure setnewcuridx(value:integer);
    function  getfredaction:boolean;
    function  getfctl3d:boolean;
    function  getstrdlm:char;
    function  getcolordlm:char;
    procedure detachwndproc;    
    procedure matrix(var _Data:TData);
    procedure columnarray(var _Data:TData);

    procedure StrDlm(Val:string);
    procedure ColorDlm(Val:string);    
    procedure ColDlm(Val:string);    
     
    procedure SetColumns(const ListCol:PStrList; Mode:integer);
    procedure _OnColumnClick(Sender: PControl; Idx: Integer);
    procedure _OnBeforeLineChange(Sender: PControl; Idx: Integer);
    procedure _OnLineChange(Sender: PControl; Idx: Integer);
    function  _OnLVCustomDraw(Sender: PControl; DC: HDC; Stage: Cardinal;
                  ItemIdx, SubItemIdx: Integer; const Rect: TRect;
                  ItemState: TDrawState; var TextColor, BackColor: TColor): Cardinal;

    procedure MX_Set(x,y:integer; var Val:TData);
    function  MX_Get(x,y:integer):TData;
    function  _mRows:integer;
    function  _mCols:integer;

    function  InitColStr(var Val:string):string;
    procedure _SetCol(var Item:TData; var Val:TData);
    function  _GetCol(Var Item:TData; var Val:TData):boolean;
    procedure _AddCol(var Val:TData);
    function  _CountCol:integer;
    procedure SetTextColLst(const Value:string);
    function  Get(index:integer):string;

    function  PakColor2Str(Data:Cardinal):string;
    procedure SetOption(OSet:boolean; Option:TListViewOption); 

    procedure _OnSelState( Sender: PControl; IdxFrom, IdxTo: Integer; OldState, NewState: cardinal );

    procedure MT_ActionItm(var Data:TData; Mode:integer);
    procedure MT_ActionCol(var Data:TData; Mode:integer);
    procedure MT_ProperCol(var Data:TData; Mode:integer);

    procedure SetLargIconsManager(value:IIconsManager);
    procedure SetSmallIconsManager(value:IIconsManager);
    procedure SetStateIconsManager(value:IIconsManager);

  public

    _event_onClick:THI_Event;
    _event_onColumnClick:THI_Event;
    _event_onCheck_MT:THI_Event;
    _event_onBeforeLineChange:THI_Event;
    _event_onLineChange:THI_Event;

    _prop_FlatScroll: boolean;
    _prop_CheckBoxes:boolean;
    _prop_HeaderDragDrop:boolean;
    _prop_RowSelect:boolean;
    _prop_DrawManager:IDrawManager;
    _prop_EventManager:IEventManager;
    
    property _prop_LargIconsManager:IIconsManager   read FLargIconsManager  write SetLargIconsManager;
    property _prop_SmallIconsManager:IIconsManager  read FSmallIconsManager write SetSmallIconsManager;
    property _prop_StateIconsManager:IIconsManager  read FStateIconsManager write SetStateIconsManager;

    property _prop_ColorItems:boolean      write FColorItems;
    property _prop_InfoTip:boolean         write FInfoTip;
    property _prop_EnableOnClick:boolean   write FEnableOnClick;
    property _prop_ColumnWidth:integer     write FColumnWidth;
    property _prop_Redaction:boolean       write FRedaction;
    property _prop_ImgColumn:boolean       write FImgColumn;
    property _prop_FullSelect:boolean      write FFullSelect;
    property _prop_ColumnClick:byte        write FColumnClick;
    property _prop_TextAlign:TTextAlign    write FTextAlign;
    property _prop_Style:TListViewStyle    write FStyle;
    property _prop_Grid:boolean            write FGrid;
    property _prop_TrackSelect:boolean     write FTrackSelect;
    property _prop_MultiSelect:boolean     write FMultiSelect;
    property _prop_StrDelimiter:string     write StrDlm;
    property _prop_ColorDelimiter:string   write ColorDlm;
    property _prop_ColDelimiter:string     write ColDlm;
    
    property _prop_Columns:string          write SetTextColLst;

    procedure Init; override;
    destructor Destroy; override;

    function getInterfaceMSTControl: IMSTControl;

    procedure _work_doStyle(var _Data:TData; Index:word);
    procedure _work_doGrid(var _Data:TData; Index:word);
    procedure _work_doInfoTip(var _Data:TData; Index:word);
    procedure _work_doTrackSelect(var _Data:TData; Index:word);
    procedure _work_doMultiSelect(var _Data:TData; Index:word);
    procedure _work_doEnableOnClick(var _Data:TData; Index:word);

    procedure _var_MTStrTbl(var _Data:TData; Index:word);
    procedure _var_TopItem(var _Data:TData; Index:word);
    procedure _var_PerPage(var _Data:TData; Index:word);
    procedure _var_ItemAtPos(var _Data:TData; Index:word);
    procedure _var_Count(var _Data:TData; Index:word);

  end;

implementation

function ThiMTStrTbl.getInterfaceMSTControl;
begin
  Result := @mtstc;
end;

function ThiMTStrTbl.ctrlpoint;
begin
  Result := Control;
end;

function ThiMTStrTbl.textalign;
begin
  Result := Control.LVColAlign[idx];
end;

function ThiMTStrTbl.smiconlist;
begin
   if Assigned(SmIList) then
     Result:= SmIList
   else
     Result:= nil;
end;

function ThiMTStrTbl.lgiconlist;
begin
   if Assigned(LgIList) then
     Result:= LgIList
   else
     Result:= nil;
end;

function ThiMTStrTbl.imgcolumn;
begin
  Result := FImgColumn;
end;

function ThiMTStrTbl.colcount;
begin
  Result := CList.Count;
end;

function ThiMTStrTbl.imgsize;
begin
  Result := FImgSize;
end;

function ThiMTStrTbl.coloritems;
begin
  Result := FColorItems;
end;

procedure ThiMTStrTbl.scoloritems;
begin
  FColorItems := val;
end;

function ThiMTStrTbl.textcolor;
begin
  Result := Control.LVTextColor;
end;

function ThiMTStrTbl.textbkcolor;
begin
  Result:= Control.LVTextBkColor;
end;

procedure ThiMTStrTbl.bkcolor;
begin
  Result:= Control.LVBkColor;
end;

function ThiMTStrTbl.gradientcolor;
begin
  Result:= FGradientColor;
end;

procedure ThiMTStrTbl.shadowcolor;
begin
  Result:= FShadowColor;
end;

function ThiMTStrTbl.iconcolcolor;
begin
  Result := FIconColColor;
end;

function ThiMTStrTbl.style;
begin
  Result := FStyle;
end;

function ThiMTStrTbl.getnewcuridx;
begin
  Result := NewCurIdx;
end;

procedure ThiMTStrTbl.setnewcuridx;
begin
   NewCurIdx := Value;
end;

function ThiMTStrTbl.getfredaction;
begin
  Result := FRedaction;
end;

function ThiMTStrTbl.getstrdlm;
begin
  Result := _StrDlm;
end;

function ThiMTStrTbl.getcolordlm;
begin
  Result := _ColorDlm;
end;

procedure ThiMTStrTbl.siconcolcolor;
begin
  FIconColColor:= Value;
  if Assigned(SmIList) then
    SmIList.BkColor:= FIconColColor;
  SetColumns(CList,1);      
end;

function ThiMTStrTbl.clistcount;
begin
  Result := CList.Count;
end;

function ThiMTStrTbl.getfctl3d;
begin
  Result := not boolean(_prop_CTL3D);
end;

procedure ThiMTStrTbl.addcols; // 
var
  s: string;
begin
  if _IsNULL(_Data) then exit;
  if not FAllMT_AddCol then
  begin
    ReadString(_Data, Null);
    ReadString(_Data, Null);
  end;      
  while not _IsNULL(_Data) do
  begin
    s := ReadString(_Data, Null);
    Replace(s, _ColDlm, '=');
    Control.LVColAdd('', FTextAlign, FColumnWidth);
    CList.Add(InitColStr(s));
  end; 
  SetColumns(CList, 1);
end;

procedure ThiMTStrTbl.clistclear;
begin
  Clist.Clear;
end;

destructor ThiMTStrTbl.Destroy;
begin
  CList.free;
  if Obj <> nil then
    Dispose(Obj);
  if CLArray <> nil then
    Dispose(CLArray);
  inherited Destroy;
end;

procedure ThiMTStrTbl._OnColumnClick;
var
  dt: TData;
begin
  case FColumnClick of
    0: begin
         _hi_OnEvent(_event_onColumnClick, Control.LVColText[Idx]);
         if Assigned(_prop_EventManager) then
         begin
           dtString(dt, Control.LVColText[Idx]);
           _prop_EventManager.oncolumnclick(dt);
         end;
       end;  
    1: begin 
         _hi_OnEvent(_event_onColumnClick, Idx);
         if Assigned(_prop_EventManager) then
         begin
           dtInteger(dt, Idx);
           _prop_EventManager.oncolumnclick(dt);
         end;
       end;  
  end;
end;

procedure ThiMTStrTbl._OnBeforeLineChange;
begin
  _hi_OnEvent(_event_onBeforeLineChange, Idx);
  if Assigned(_prop_EventManager) then  
    _prop_EventManager.onbeforelinechange(idx);
end;

procedure ThiMTStrTbl._OnLineChange;
begin
  _hi_OnEvent(_event_onLineChange, Idx);
  if Assigned(_prop_EventManager) then  
    _prop_EventManager.onlinechange(idx);  
end;

//---------------------       -----------------------

procedure ThiMTStrTbl._OnSelState;
var
  dt, Data: TData;
begin
  dtNull(Data);
  if (Newstate = 3) or (Newstate = 1) then
  begin
    if FEnableOnClick then
    begin
      _hi_OnEvent(_event_onClick, IdxFrom);
      if Assigned(_prop_EventManager) then
        _prop_EventManager.onclick(IdxFrom);      
    end;  
    exit;
  end;
  if (Newstate = $2000) and (OldState = $1000) then
    dtInteger(dt, 1)
  else if (Newstate = $1000) and (OldState = $2000) then
    dtInteger(dt, 0)
  else
    exit;         
  dtInteger(Data, IdxFrom);
  Data.ldata := @dt;
  _hi_onEvent_(_event_onCheck_MT, Data);
  if Assigned(_prop_EventManager) then
    _prop_EventManager.oncheckmt(Data);
end;

//---------------------       -----------------------

function ThiMTStrTbl._OnLVCustomDraw;
const
  AColor: array [0..15] of TColor = (clBlack, clMaroon, clGreen, clOlive,
                                     clNavy, clPurple, clTeal, clGray,
                                     clSilver, clRed, clLime, clYellow,
                                     clBlue, clFuchsia, clAqua, clWhite);
var
  Color, bkColor: TColor;
  idxColor: Cardinal;
begin
  Result := CDRF_DODEFAULT;
  if (Stage = CDDS_PREPAINT) then
    Result := CDRF_NOTIFYITEMDRAW
  else if (Stage = CDDS_ITEMPREPAINT) then
  begin 
    if (Sender.LVItemData[ItemIdx] <> 0) and FColorItems then
    begin
      Color := Sender.LVItemData[ItemIdx];
      bkColor := $00FFFFFF and Color;
      if bkColor <> 0 then
        BackColor := bkColor
      else
        BackColor := Color2RGB(Sender.LVBkColor);
      idxColor := ($0F000000 and Color) shr 24;
      if idxColor <> 0 then
        TextColor := AColor[idxColor]
      else
        TextColor := Color2RGB(Sender.LVTextColor);
    end
    else
    begin 
      BackColor := Color2RGB(Sender.LVTextBkColor);
      TextColor := Color2RGB(Sender.LVTextColor);
    end;
    Result := CDRF_NOTIFYSUBITEMDRAW OR CDRF_NOTIFYPOSTPAINT;
  end
  else if ((Stage = CDDS_SUBITEM + CDDS_ITEMPREPAINT) or (Stage = CDDS_ITEMPOSTPAINT))
          and ((Sender.LVStyle = lvsDetail) or (Sender.LVStyle = lvsDetailNoHeader))
          and Assigned(_prop_DrawManager) then
    Result := _prop_DrawManager.customdraw(Sender, DC, Stage, ItemIdx, SubItemIdx, Rect,
                                           ItemState, TextColor, BackColor, FGradientColor,
                                           FShadowColor, NewCurIdx, SmIList, StIList);
end;
//-------------------    ---------------------

//------------------------------------------------------------------------

function ThiMTStrTbl.PakColor2Str;
var
  hcl, lcl: string;
  idxcl: Cardinal;
begin
  lcl := int2str($FFFFFF and Data);
  idxcl := $0F000000 and Data;
  hcl := int2str(idxcl shr 24);
  Result := hcl + _ColorDlm + lcl;
end;

procedure ThiMTStrTbl.StrDlm;
begin
  if Val = '' then
    _StrDlm:= ' '
  else
    _StrDlm:= Val[1];
end;

procedure ThiMTStrTbl.ColorDlm;
begin
  if Val = '' then
    _ColorDlm:= '#'
  else
    _ColorDlm:= Val[1];
end;

procedure ThiMTStrTbl.ColDlm;
begin
  if Val = '' then
    _ColDlm:= '_'
  else
    _ColDlm:= Val[1];
end;
//==============================================================================

function WndProcTabGrid(Sender: PControl; var Msg: TMsg; var Rslt: Integer): Boolean;
type
  TMouseDownPt = packed record
    X: Word;
    Y: Word;
  end;
var
  R, ARect: TRect;
  Pt: TMouseDownPt; 
  HTI: TLVHitTestInfo;
  fClass: ThiMTStrTbl;
  l: TListViewOptions;

  procedure EscCell(NewLine: integer);
  begin
    R := Sender.LVItemRect(NewLine, lvipBounds);
    ARect := Sender.LVItemRect(NewLine, lvipLabel);
    R.Left := ARect.Left;
    InvalidateRect(Sender.Handle, @R, false);
  end;
  
begin
  Result := FALSE;
  l:= Sender.LVOptions;
  fClass := ThiMTStrTbl(Sender.Tag);
  with fClass do
  begin
    case Msg.message of
      WM_RBUTTONDOWN, WM_LBUTTONDOWN:
      begin
        Pt:= TMouseDownPt(Msg.lParam);
        HTI.pt.x := Pt.X;
        HTI.pt.y := Pt.Y;
        Sender.Perform( LVM_SUBITEMHITTEST, 0, Integer( @HTI ) );
        if HTI.flags <> LVHT_ONITEMSTATEICON then
        begin 
          NewLine := HTI.iItem;
          NewCurIdx := HTI.iSubItem;             
        end;
        EscCell(NewLine);
      end;
      WM_KEYDOWN:
      begin
        Case Msg.WParam of
          VK_LEFT, VK_RIGHT:
          begin
            if (lvoRowSelect in l) then
            begin
              NewCurIdx := NewCurIdx + Msg.wParam - $26;
              if NewCurIdx >= Sender.LVColCount then
                NewCurIdx := Sender.LVColCount - 1
              else
                if NewCurIdx < 0 then NewCurIdx := 0;
              EscCell(NewLine);
            end;
          end;
          VK_UP, VK_DOWN:
          begin
            if (lvoRowSelect in l) then
            begin
              NewLine := NewLine + Msg.wParam - $27;                  
              if NewLine >= Sender.Count then
                NewLine := Sender.Count - 1
              else
                if NewLine < 0 then
                  NewLine := 0;
              EscCell(NewLine);
            end;
          end;
        end;
      end;
    end;
  end;
end;

//==============================================================================

procedure ThiMTStrTbl.detachwndproc;
begin
  if Control.IsProcAttached(WndProcTabGrid) then
    Control.DetachProc(WndProcTabGrid);
end;

procedure ThiMTStrTbl.Init;
var
  l: TListViewOptions;
begin
  l := [lvoUnderlineHot];

  if FInfoTip then
    include(l, lvoInfoTip);
  if FTrackSelect then
    include(l, lvoTrackSelect);
  if _prop_HeaderDragDrop then
    include(l, lvoHeaderDragDrop);
  if _prop_CheckBoxes then
    include(l, lvoCheckBoxes);
  if FMultiSelect then
    include(l, lvoMultiSelect);
  if FGrid then
    include(l, lvoGridLines);
  if _prop_RowSelect then
    include(l, lvoRowSelect);
  if _prop_FlatScroll then
    include(l, lvoFlatsb);
   
  FGradientColor := clHighlight;
  FShadowColor   := clHighlightText;
  FIconColColor  := clBtnFace;

  if _prop_StateIconsManager = nil then
    StIList := nil
  else 
    StIList := _prop_StateIconsManager.iconlist;

  if _prop_SmallIconsManager = nil then
    SmIList := nil
  else
  begin 
    SmIList  := _prop_SmallIconsManager.iconlist;
    FImgSize := _prop_SmallIconsManager.imgsz;
    SmIList.BkColor := FIconColColor;
  end;

  if _prop_LargIconsManager = nil then
    LgIList := nil
  else 
    LgIList := _prop_LargIconsManager.iconlist;

  if FRedaction then
    Control := NewListEdit(FParent, FStyle, l, LgIList, SmIList, StIList,
                           _OnLineChange, _OnBeforeLineChange)
  else
    Control := NewListView(FParent, FStyle, l, LgIList, SmIList, StIList);

  mtstc.ctrlpoint      := ctrlpoint;
  mtstc.actionitm      := MT_ActionItm;
  mtstc.actioncol      := MT_ActionCol;
  mtstc.propercol      := MT_ProperCol;
  mtstc.textalign      := textalign;
  mtstc.smiconlist     := smiconlist;
  mtstc.lgiconlist     := lgiconlist;  
  mtstc.imgcolumn      := imgcolumn;
  mtstc.colcount       := colcount;
  mtstc.imgsize        := imgsize;     
  mtstc.coloritems     := coloritems;
  mtstc.scoloritems    := scoloritems;
  mtstc.textbkcolor    := textbkcolor;
  mtstc.textcolor      := textcolor;
  mtstc.bkcolor        := bkcolor;
  mtstc.gradientcolor  := gradientcolor;
  mtstc.shadowcolor    := shadowcolor;  
  mtstc.addcols        := addcols;
  mtstc.stextbkcolor   := stextbkcolor;
  mtstc.stextcolor     := stextcolor;
  mtstc.sbkcolor       := sbkcolor;
  mtstc.sgradientcolor := sgradientcolor;
  mtstc.sshadowcolor   := sshadowcolor;
  mtstc.siconcolcolor  := siconcolcolor;
  mtstc.iconcolcolor   := iconcolcolor;  
  mtstc.deletecol      := deletecol;
  mtstc.clistclear     := clistclear;
  mtstc.clistcount     := clistcount;
  mtstc.style          := style;
  mtstc.setfocus       := _work_doSetFocus;
  mtstc.matrix         := matrix;
  mtstc.mxget          := MX_Get;
  mtstc.mxset          := MX_Set;  
  mtstc.getnewcuridx   := getnewcuridx;
  mtstc.setnewcuridx   := setnewcuridx;
  mtstc.getfredaction  := getfredaction;
  mtstc.getfctl3d      := getfctl3d;
  mtstc.pakcolortostr  := PakColor2Str;
  mtstc.getstrdlm      := getstrdlm; 
  mtstc.getcolordlm    := getcolordlm;
  mtstc.detachwndproc  := detachwndproc;
  mtstc.getstring      := Get;
  mtstc.columnarray    := columnarray; 

  SetColumns(CList,0);

  inherited;

  Control.OnColumnClick   :=  _OnColumnClick;
  Control.OnLVCustomDraw  :=  _OnLVCustomDraw;
  Control.LVTextColor     := Control.Font.Color;
  Control.LVTextBkColor   := Control.Color;
  Control.LVBkColor       := Control.Color;
  Control.OnLVStateChange := _OnSelState;
  Control.Tag             := Cardinal(Self);
  Control.AttachProc(WndProcTabGrid);
 
end;

procedure ThiMTStrTbl.SetTextColLst;
begin
  CList := NewStrList;
  Clist.Text := Value;
end;

procedure ThiMTStrTbl.SetColumns;
var
  i: integer;
  s, str, sd: string;
begin
  if ListCol.Count = 0 then exit;
  i:= 0;
  Control.BeginUpdate;
  repeat
    s := ListCol.Items[i] + '=';
    sd := GetTok(s, '=');
    if sd <> '' then
    begin
      str := sd;
      case Mode of
        0: Control.LVColAdd(sd, FTextAlign, FColumnWidth);
        1: Control.LVColText[i] := sd;
      end;
      sd := GetTok(s, '=');
      if sd = '' then
        sd:= int2str(FColumnWidth)
      else
        Control.LVColWidth[i] := str2int(sd);
      str := str + '=' + sd;
      sd := GetTok(s, '=');
      if FImgColumn and Assigned(SmIlist) and (SmIList.Count <> 0) then
        if sd = '' then
          Control.LVColImage[i] := I_SKIP
        else  
          Control.LVColImage[i] := str2int(sd);
      str := str + '=' + sd;
      sd := GetTok(s, '=');
      if sd <> '' then
        Control.LVColAlign[i] := TTextAlign(str2int(sd))
      else
      begin
        Control.LVColAlign[i] := FTextAlign;
        sd := int2str(ord(Control.LVColAlign[i]));
      end;
      str := str + '=' + sd;
      ListCol.Items[i] := str;
    end;
    inc(i);
  until i = ListCol.Count; 
  Control.EndUpDate;
end;

function ThiMTStrTbl.Get;
var
  i: integer;
  s: string;
begin
  Result := '';
  if Control.LVColCount > 0 then
  begin
    s := '';
    if Assigned(SmIlist) and FFullSelect then
      s := int2str(Control.LVItemImageIndex[Index]) + _StrDlm;
    if FColorItems and FFullSelect then
      s := s + PakColor2Str(Control.LVItemData[Index]) + _StrDlm;;
    for i := 0 to Control.LVColCount - 1 do
    begin
      s := s + Control.LVItems[Index, i];
      if i < Control.LVColCount - 1 then
        s := s + _StrDlm;
    end;
    Result:= s;   
  end;
end;

//ItemAtPos -   ,    PosX, PosY  
//
procedure ThiMTStrTbl._var_ItemAtPos;
begin
   dtInteger(_Data, Control.LVItemAtPos(Ms.X, Ms.Y));
end;

//StringTable -    
//
procedure ThiMTStrTbl._var_MTStrTbl;
begin
  _Data.Data_type := data_int;
  _Data.sdata := 'StringTable';
  _Data.idata := integer(Control);
end;

//#####################################################################
//#                                                                   #
//#                                                   #
//#                                                                   #
//#####################################################################

procedure ThiMTStrTbl.stextcolor;
begin
  Control.LVTextColor := Value;
end;

procedure ThiMTStrTbl.stextbkcolor;
begin
  Control.LVTextBkColor := Value;
end;

procedure ThiMTStrTbl.sbkcolor;
begin
  Control.LVBkColor := Value;
end;

procedure ThiMTStrTbl.sgradientcolor;
begin
  FGradientColor := Value;
end;

procedure ThiMTStrTbl.sshadowcolor;
begin
  FShadowColor := Value;
end;

procedure ThiMTStrTbl._work_doStyle;
begin
  FStyle := TListViewStyle(ToInteger(_Data));
  Control.LVStyle := FStyle;
  SetColumns(Clist, 1);
end;

procedure ThiMTStrTbl._work_doEnableOnClick;
begin
  FEnableOnClick := ReadBool(_Data);
end;

procedure ThiMTStrTbl._work_doGrid;
begin
  FGrid := ReadBool(_Data);
  SetOption(FGrid, lvoGridLines);
end;

procedure ThiMTStrTbl._work_doTrackSelect;
begin
  FTrackSelect := ReadBool(_Data);
  SetOption(FTrackSelect, lvoTrackSelect);
end;

procedure ThiMTStrTbl._work_doMultiSelect;
begin
  FMultiSelect := ReadBool(_Data);
  SetOption(FMultiSelect, lvoMultiSelect);
end;

procedure ThiMTStrTbl._work_doInfoTip;
begin
  FInfoTip := ReadBool(_Data);
  SetOption(FInfoTip, lvoInfoTip);
end;

procedure ThiMTStrTbl.SetOption;
var
  l:TListViewOptions;
begin
  l := Control.LVOptions;
  if OSet then
    include(l, Option)
  else
    exclude(l, Option);
  Control.LVOptions := l;
end;

//#####################################################################
//#                                                                   #
//#                               #
//#                                                                   #
//#####################################################################

//------------------         --------------------

//ColumnArray -    
//
procedure ThiMTStrTbl.columnarray;
begin
  if not Assigned(CLArray) then
    CLArray := CreateArray(_SetCol, _GetCol, _CountCol, _AddCol);
  dtArray(_Data, CLArray);
end;

procedure ThiMTStrTbl._SetCol;
var
  s: string;
  ind: integer;
begin
  ind := ToIntIndex(Item);
  s := ToString(Val);
  if (ind >= 0) and (ind < CList.Count) then
    CList.Items[ind] := InitColStr(s);
  SetColumns(CList, 1);
end;

function ThiMTStrTbl._GetCol;
var
  ind: integer;
begin
  ind := ToIntIndex(Item);
  Result := True;
  if (ind >= 0) and (ind < CList.Count) then
    dtString(Val, Clist.Items[ind])
  else
    Result := False;
end;

procedure ThiMTStrTbl._AddCol;
var
  s: string;
begin
  s := ToString(Val);
  Control.LVColAdd('', FTextAlign, FColumnWidth);
  CList.Add(InitColStr(s));
  SetColumns(CList, 1);
end;

function ThiMTStrTbl._CountCol;
begin
  Result := CList.Count;
end;

//--------------------       -----------------------

//    
//
procedure ThiMTStrTbl.deletecol;
var
  ind: integer;
begin
  ind := ToInteger(_Data);
  if (ind >= 0) and (ind < CList.Count) then
  begin
    Control.LVColDelete(ind);
    CList.Delete(ind);
  end;
  SetColumns(CList,1);
end;

function ThiMTStrTbl.InitColStr;
var
  s, ss, sd, se, sf, sh: string;
begin
  s := val;
  sf := s + '=';
  ss := GetTok(sf, '=');
  sd := GetTok(sf, '=');
  sh := GetTok(sf, '=');
  se := GetTok(sf, '=');
  if s = '' then
    s := '=' + int2str(FColumnWidth) + '=' + int2str(integer(FTextAlign))
  else
  begin
    if sd = '' then sd := int2str(FColumnWidth);
    if se = '' then se := int2str(integer(FTextAlign));
    s := ss + '=' + sd + '=' + sh + '=' + se;
  end;
  Result := s;
end;

//#####################################################################
//#                                                                   #
//#                                                #
//#                                                                   #
//#####################################################################

//Matrix -  
//
procedure ThiMTStrTbl.Matrix;
begin
  if not Assigned(Obj) then
  begin
    New(Obj);
    Obj._Set  := MX_Set;
    Obj._Get  := MX_Get;
    Obj._Rows := _mRows; 
    Obj._Cols := _mCols; 
  end;
  dtMatrix(_Data, Obj);
end;

function ThiMTStrTbl.MX_Get;
begin
  if (x >= 0) and (y >= 0) and (y < Control.Count) and (x < Control.LVColCount) then
    dtString(Result, Control.LVItems[y,x])
  else
    dtNull(Result);
end;

procedure ThiMTStrTbl.MX_Set;
begin
  if (x >= 0) and (y >= 0) and (y < Control.Count) and (x < Control.LVColCount) then
    Control.LVItems[y,x] := ToString(Val);
end;

function ThiMTStrTbl._mRows;
begin
  Result := Control.Count; 
end;

function ThiMTStrTbl._mCols;
begin
  Result := Control.LVColCount; 
end;

//#####################################################################
//#                                                                   #
//#                           MT-                               #
//#                                                                   #
//#####################################################################

// MT-    
//
procedure ThiMTStrTbl.MT_ActionItm; // 
var
  Row, Col, iconum, ind: integer;
  ss: string;
  DColor: Cardinal;
begin
  Row := Control.Count;
  if (Mode = ITM_INSERT) or (Mode = ITM_REPLACE) then
    if not _IsNULL(Data) then
    begin
      Row := ReadInteger(Data,Null);   
      if (Row > Control.Count - 1) then exit;
    end;
  Col := 0;
  iconum := I_SKIP;
  DColor := 0;
  if (Assigned(SmIlist) and (Control.LVStyle <> lvsIcon)) or
     (Assigned(LgIlist) and (Control.LVStyle = lvsIcon))  and not _IsNULL(Data) then
  begin
    iconum := ReadInteger(Data, Null);
    if (Assigned(SmIlist) and (Control.LVStyle <> lvsIcon)) then
      if iconum > SmIList.Count - 1 then
        iconum := I_SKIP
    else if (Assigned(LgIlist) and (Control.LVStyle = lvsIcon)) then    
      if iconum > LgIList.Count - 1 then
        iconum := I_SKIP
  end;
  if FColorItems and not _IsNULL(Data) then
  begin
    ss := ReadString(Data, Null) + _ColorDlm;
    DColor := Cardinal(Str2Int(GetTok(ss, _ColorDlm)) shl 24 + Str2int(ss));
  end;
  if not _IsNULL(Data) and not (Row < 0) then
  begin
    if Mode = ITM_ADD then
      Control.LVItemAdd('')
    else if (Mode = ITM_INSERT) and (Row < Control.Count) then
      Control.LVItemInsert(Row, '');     
    ind := Control.LVCurItem; //   
    while not _IsNULL(Data) and (Row < Control.Count) do
    begin
      Control.LVSetItem(Row, Col, ReadString(Data, Null), iconum, [], I_SKIP, I_SKIP, DColor);
      inc(Col);
    end;
    Control.LVCurItem := ind; //   
  end;
end;

// MT-   
//
procedure ThiMTStrTbl.MT_ActionCol; // 
var
  s: string;
  ind: integer;
begin
  if _IsNULL(Data) then exit;
  ind := ReadInteger(Data, Null); 
  s := ReadString(Data, Null);   
  Replace(s, _ColDlm, '=');
  if (Mode = ITM_INSERT) and (ind >= 0) then
  begin
    if (ind > CList.Count - 1) then
    begin
      Control.LVColAdd('', FTextAlign, FColumnWidth);
      CList.Add(InitColStr(s));
    end
    else
    begin
      Control.LVColInsert(ind, '', FTextAlign, FColumnWidth);
      CList.Insert(ind, InitColStr(s));
    end;
  end
  else if (Mode = ITM_REPLACE) and not ((ind < 0) or (ind > CList.Count - 1)) then
    CList.Items[ind] := InitColStr(s)
  else
    exit;
  SetColumns(CList, 1);
end;

// MT-    
//
procedure ThiMTStrTbl.MT_ProperCol; // 
var
  s, name, width, imgidx, aligntxt: string;
  ind: integer;
begin
  if _IsNULL(Data) then exit;
  ind := ReadInteger(Data, Null);   
  s := ReadString(Data, Null);   
  if (ind < 0) or (ind > CList.Count - 1) then exit;
  name := Control.LVColText[ind];
  width := int2str(Control.LVColWidth[ind]);
  imgidx := int2str(Control.LVColImage[ind]);
  aligntxt := int2str(ord(Control.LVColAlign[ind]));  
  if Mode = COL_NAME then
    name := s
  else if Mode = COL_WIDTH then
    width := s
  else if Mode = COL_IMAGE then
    imgidx := s
  else if Mode = COL_ALIGN then
    aligntxt := s
  else
    exit;   
  s := name + '=' + width + '=' + imgidx + '=' + aligntxt;
  CList.Items[ind] := InitColStr(s);
  SetColumns(CList, 1);
end;

//   ,     
//
procedure ThiMTStrTbl._var_TopItem;
begin
  dtInteger(_Data, Control.LVTopItem);
end;

//    ,    
//
procedure ThiMTStrTbl._var_PerPage;
begin
  dtInteger(_Data, Control.LVPerPage);
end;

//     
//
procedure ThiMTStrTbl._var_Count;
begin
  dtInteger(_Data, Control.Count);
end;

//    
//
procedure ThiMTStrTbl.SetLargIconsManager;
begin
  if value <> nil then
  begin
    FLargIconsManager := value;
    LgIList := value.iconList;
    if Assigned(Control) then
      Control.ImageListNormal := LgIList;
  end;
end;

procedure ThiMTStrTbl.SetSmallIconsManager;
begin
  if value <> nil then
  begin
    FSmallIconsManager := value;
    SmIList := value.iconList; 
    FImgSize := value.imgsz;
    SmIList.BkColor := FIconColColor;
    Control.ImageListSmall := SmIList;
    SetColumns(CList,1);  
  end;
end;

procedure ThiMTStrTbl.SetStateIconsManager;
begin
  if value <> nil then
  begin
    FStateIconsManager := value;
    StIList := value.iconList;
    if Assigned(Control) then
      Control.ImageListState := StIList;
  end;
end;

//
//----------------------------      ------------------------------
end.